;============================================================================
;
;                   VPCX.ASM
;
;           (c) 08-07-96 par Sebastien HELLEU
;		mis a jour par Pierre Barbier de Reuille, Julien Viard 
;			et Gabriel Dubois
;
;       Mini-visualiseur de PCX au format 320*200, 256 couleurs
;
;              Syntaxe: VPCX <nomfich.pcx
;
;============================================================================

    .MODEL TINY
    .286
    .CODE
    org 100h
Code:
    mov al,13h
    int 10h
    mov ah,3fh
    mov ch,0fch
    mov dx,offset Buffer
    int 21h
    mov si,ax
    mov ch,3        ; CL=0
shift_pal:
    shr byte ptr ds:[si],2
    inc si
    loop    shift_pal
    xchg    ax,dx
    mov ch,01h      ; CL=0 ==> cx=0100h=256
    mov ax,1012h
    int 10h
    mov bh,0A0h     ; BL=0
    mov es,bx
    mov si,offset Buffer+128
    xor di,di
Boucle_affiche:
    lodsb
    cmp al,0C0h
    jb Suite
Plusieurs:
    sub al,0C0h
    cbw
    xchg cx,ax
    dec cx
    lodsb
    rep stosb
Suite:
    stosb
    cmp di,64000
    jb  Boucle_affiche
    int 16h
Fin:
    mov ax,0003h
    int 10h
    ret

    org 768
Buffer  db 64766 dup (?)
END Code

